diff --git a/Documentation/devicetree/bindings/usb/ci-hdrc-usb2.yaml b/Documentation/devicetree/bindings/usb/ci-hdrc-usb2.yaml
index 11d08ffeb1e9c..c467924235759 100644
--- a/Documentation/devicetree/bindings/usb/ci-hdrc-usb2.yaml
+++ b/Documentation/devicetree/bindings/usb/ci-hdrc-usb2.yaml
@@ -255,15 +255,94 @@ allOf:
           minimum: 0x0
           maximum: 0x3
 
+        samsung,picophy-usb-source-impedance-adjust:
+          description: |
+            USB Source Impedance Adjustment. In some applications, there can be
+            significant series resistance on the USB DP/DN path between the
+            USB_OTG*_DP/USB_OTG*_DN pins tns and the USB cable. This bus adjusts
+            the driver source impedance to compensate for that added resistance.
+            The default value is 0x1. For more details refer to TXRESTUNE0 bits of
+            USBNC_n_PHY_CFG1.
+
+          $ref: /schemas/types.yaml#/definitions/uint32
+          minimum: 0x0
+          maximum: 0x3
+
+        samsung,picophy-hs-rise-time-adjust:
+          description: |
+            This bus adjust the rise/fall times of the high-speed transmitter
+            waveform. The default value is 0x1. For more details refer to
+            TXRISETUNE0 bits of USBNC_n_PHY_CFG1.
+
+          $ref: /schemas/types.yaml#/definitions/uint32
+          minimum: 0x0
+          maximum: 0x3
+
         samsung,picophy-dc-vol-level-adjust:
           description: |
             HS DC Voltage Level Adjustment. Adjust the high-speed transmitter DC
             level voltage. The range is from 0x0 to 0xf, the default value is
             0x3. Details can refer to TXVREFTUNE0 bits of USBNC_n_PHY_CFG1.
+
+        $ref: /schemas/types.yaml#/definitions/uint32
+          minimum: 0x0
+          maximum: 0xf
+
+        samsung,picophy-fs-ls-source-impedance-adjust:
+          description: |
+            FS/LS Source Impedance Adjustment. This bus adjusts the low- and
+            full-speed single-ended source impedance while driving high. The
+            adjustment values listed are based on nominal process, voltage, and
+            temperature conditions. The default value is 0x3. For more details
+            refer to TXFSLSTUNE0 bits of USBNC_n_PHY_CFG1.
+
           $ref: /schemas/types.yaml#/definitions/uint32
           minimum: 0x0
           maximum: 0xf
 
+        samsung,picophy-transmitter-hs-crossover-adjust:
+          description: |
+            Transmitter High-Speed Crossover Adjustment. This bus adjusts the
+            voltage at which the USB_OTG*_DP and USB_OTG*_DN signals cross
+            while transmitting in HS mode. The default value is 0x3. For more
+            details refer to TXHSXVTUNE0 bits of USBNC_n_PHY_CFG1.
+
+          $ref: /schemas/types.yaml#/definitions/uint32
+          minimum: 0x0
+          maximum: 0x3
+
+        samsung,picophy-vbus-valid-threshold-adjust:
+          description: |
+            VBUS Valid Threshold Adjustment. This bus adjust the voltage level
+            for the VBUS VALID threshold. The default value is 0x4. For more
+            details refer to OTGTUNE0 bits of USBNC_n_PHY_CFG1.
+
+          $ref: /schemas/types.yaml#/definitions/uint32
+          minimum: 0x0
+          maximum: 0x7
+
+        samsung,picophy-squelsh-threshold-adjust:
+          description: |
+            Squelch Threshold Adjustment. This bus adjusts the voltage level for
+            the receiver threshold used to detect valid high-speed data. The
+            default value is 0x3. For more details refer to SQRXTUNE0 bits of
+            USBNC_n_PHY_CFG1.
+
+          $ref: /schemas/types.yaml#/definitions/uint32
+          minimum: 0x0
+          maximum: 0x7
+
+        samsung,picophy-disconnect-threshold-adjust:
+          description: |
+            Disconnect Threshold Adjustment. This bus adjusts the voltage level for
+            the receiver threshold used to detect a disconnect event at the host.
+            The default value is 0x4. For more details refer to COMPDISTUNE0 bits of
+            USBNC_n_PHY_CFG1.
+
+          $ref: /schemas/types.yaml#/definitions/uint32
+          minimum: 0x0
+          maximum: 0x7
+
 additionalProperties: true
 
 examples: